#include "G4EnergieMacro.hh"
#include "G4MacroMenu.hh"
#include <TString.h>
#include <stdlib.h>
#include <TGLabel.h>
#include <TGComboBox.h>
#include "TGTextEntry.h"
#include "TGTextView.h"
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <float.h>

using std::string;

enum AliEnergyMessageTypes {
  kM_OK_ENERGYMACRO,
  kM_CLEAR_ENERGYMACRO,
  kM_EXIT_ENERGYMACRO
};

G4EnergieMacro::G4EnergieMacro(G4MacroMenu* ee, const TGWindow *p, const TGWindow *main, UInt_t w, UInt_t h, UInt_t options) : TGTransientFrame(p, main, w, h, options), emacroMenu(ee)
{
  unitmacro = " keV";

  fLEnergieMacroFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop, 10, 10, 10, 10);
  fEnergieMacroFrame = BuildEnergieMacroFrame(this);
  AddFrame(fEnergieMacroFrame, fLEnergieMacroFrame); 

  fLEnergieMacroInputEntry = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop, 10, 10, 10, 10);
  fEnergieMacroInputFrame = BuildEnergieMacroInputEntry(fEnergieMacroFrame);
  fEnergieMacroFrame->AddFrame(fEnergieMacroInputFrame, fLEnergieMacroInputEntry); 

  fLEnergieMacroComboFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop, 10, 10, 10, 10);
  fEnergieMacroComboFrame = BuildEnergieMacroComboFrame(fEnergieMacroFrame);
  fEnergieMacroFrame->AddFrame(fEnergieMacroComboFrame, fLEnergieMacroComboFrame); 
 

  fLEnergieMacroDefFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop, 10, 10, 10, 10);
  fEnergieMacroDefFrame = BuildEnergieMacroDefFrame(fEnergieMacroFrame);
  fEnergieMacroFrame->AddFrame(fEnergieMacroDefFrame, fLEnergieMacroDefFrame); 

 fLEnergieMacroButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsBottom,0, 0, 0, 0);
  fEnergieMacroButtonFrame = BuildEnergieMacroButtonFrame(this);
  AddFrame(fEnergieMacroButtonFrame, fLEnergieMacroButtonFrame);


MapSubwindows();

SetWindowName("choix de l'energie de la particule primaire");

Layout();


MapWindow();

}


G4EnergieMacro::~G4EnergieMacro() 
{


 if (fOkEnergieMacroButton)
   delete fOkEnergieMacroButton;
 if (fClearEnergieMacroButton)
   delete fClearEnergieMacroButton;
 if (fExitEnergieMacroButton)
   delete fExitEnergieMacroButton;
  
 if (fLEnergieMacroInputEntry)
   delete fLEnergieMacroInputEntry; 
 if (fLEnergieMacroComboFrame)
   delete fLEnergieMacroComboFrame; 
 if (fLEnergieMacroFrame)
   delete fLEnergieMacroFrame; 
 if (fLEnergieMacroDefFrame)
   delete fLEnergieMacroDefFrame;
 if (LEnergieMacroFrame)
   delete LEnergieMacroFrame; 
 if (LEnergieMacroDefFrame)
   delete LEnergieMacroDefFrame;
 if (fLComboem)
   delete fLComboem;
 if (fLComboEnergieMacroLabel)
   delete fLComboEnergieMacroLabel;
 if (fLEnergieMacroButtonFrame)
   delete fLEnergieMacroButtonFrame;
 if (fButtonem)
   delete fButtonem;
 if (LEnergieMacroInputLine)
   delete LEnergieMacroInputLine;
 if (fLInputEnergieMacroLabel)
   delete fLInputEnergieMacroLabel;
 if (fLEnergieMacroDefLabel)
   delete fLEnergieMacroDefLabel;
 
 if (fEnergieMacroInputFrame)
   delete fEnergieMacroInputFrame;
 if (fEnergieMacroFrame)
   delete fEnergieMacroFrame;
 if (fEnergieMacroDefFrame)
   delete fEnergieMacroDefFrame;
 if (fEnergieMacroComboFrame)
   delete fEnergieMacroComboFrame;
 if (fEnergieMacroButtonFrame)
   delete fEnergieMacroButtonFrame;

 if (fInputEnergieMacroEntry)
   delete fInputEnergieMacroEntry;
 if (fDefEnergieMacroEntry)
   delete fDefEnergieMacroEntry;

 if (fComboEnergieMacroLabel)
   delete fComboEnergieMacroLabel;
 if (fInputEnergieMacroLabel)
   delete fInputEnergieMacroLabel;
 if (fDefEnergieMacroLabel)
   delete fDefEnergieMacroLabel;

 if (fComboEnergieMacro)
   delete fComboEnergieMacro;


}

void G4EnergieMacro::CloseWindow()
{
  delete this;
}

void G4EnergieMacro::OkEnergieMacro()
{
  
  Int_t EnergieMacroSelectionID = fComboEnergieMacro->GetSelected();

  switch(EnergieMacroSelectionID) {
  case 1:
    unitmacro = " eV";
    break;
  case 2:
    unitmacro = " keV";
    break;
  case 3:
    unitmacro = " MeV";
    break;
  case 4:
    unitmacro = " GeV";
    break;
  case 5:
    unitmacro = " TeV";
    break;
  }
  TString text1 = "L'energie de la particule primaire est : ";
  TString text2 = text1+fInputEnergieMacroEntry->GetText()+unitmacro;
  emacroMenu->GetSourceTextView()->AddLine(text2);
}


TGCompositeFrame* G4EnergieMacro::BuildEnergieMacroFrame(const TGWindow* q)
{
  TGCompositeFrame *energieframe = new TGCompositeFrame(q, 100, 100, kHorizontalFrame);
  LEnergieMacroFrame = new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2);

  return energieframe;

}


TGCompositeFrame* G4EnergieMacro::BuildEnergieMacroDefFrame(const TGWindow* r) {

  TGCompositeFrame *endefmacro = new TGCompositeFrame(r, 100, 100, kVerticalFrame);

  LEnergieMacroDefFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsBottom | kLHintsTop, 2, 2, 2, 2);

  fDefEnergieMacroEntry = new TGTextEntry(endefmacro, new TGTextBuffer(20));
  fDefEnergieMacroEntry->Insert("32.00565 keV");
  endefmacro->AddFrame(fDefEnergieMacroEntry, LEnergieMacroDefFrame);

 fDefEnergieMacroLabel = new TGLabel(endefmacro, "Valeur par defaut de l'energie");
  fLEnergieMacroDefLabel = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsBottom | kLHintsTop, 2, 2, 2, 2);
  endefmacro->AddFrame(fDefEnergieMacroLabel,fLEnergieMacroDefLabel);

  return endefmacro;
}


TGCompositeFrame* G4EnergieMacro::BuildEnergieMacroButtonFrame(const TGWindow* p)
{
  TGCompositeFrame *buttonem = new TGCompositeFrame(p, 100, 100, kHorizontalFrame);
  fButtonem = new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2);

  fOkEnergieMacroButton = new TGTextButton(buttonem, "&Ok", kM_OK_ENERGYMACRO);
  fOkEnergieMacroButton->Associate(this);
  fOkEnergieMacroButton->SetToolTipText("Choix de l'energie");
  fOkEnergieMacroButton->Connect("Clicked()", "G4EnergieMacro", this, "OkEnergieMacro()");
  buttonem->AddFrame(fOkEnergieMacroButton, fButtonem);

  fClearEnergieMacroButton = new TGTextButton(buttonem, "&Clear", kM_CLEAR_ENERGYMACRO);
  fClearEnergieMacroButton->Associate(this);
  fClearEnergieMacroButton->SetToolTipText("Clear Energy Entry Line");
  fClearEnergieMacroButton->Connect("Clicked()", "G4EnergieMacro", this, "ClearEnergieMacro()"); 
  buttonem->AddFrame(fClearEnergieMacroButton, fButtonem);

  fExitEnergieMacroButton = new TGTextButton(buttonem, "&Exit", kM_EXIT_ENERGYMACRO);
  fExitEnergieMacroButton->Associate(this);
  fExitEnergieMacroButton->SetToolTipText("Close Energy Window");
  buttonem->AddFrame(fExitEnergieMacroButton, fButtonem);
  fExitEnergieMacroButton->Connect("Clicked()", "G4EnergieMacro", this, "SendCloseMessage()"); 


  return buttonem;

}


TGCompositeFrame* G4EnergieMacro::BuildEnergieMacroComboFrame(const TGWindow* a)
{
  TGCompositeFrame *fComboem = new TGCompositeFrame(a, 100, 100, kVerticalFrame);

  fLComboem = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsBottom | kLHintsTop, 2, 2, 2, 2);


  fComboEnergieMacro = new TGComboBox(fComboem, 100);
  fComboem->AddFrame(fComboEnergieMacro, fLComboem);

  fComboEnergieMacro->Resize(120, 25);
  fComboEnergieMacro->AddEntry("eV", 1);
  fComboEnergieMacro->AddEntry("keV",2);
  fComboEnergieMacro->AddEntry("MeV",3);
  fComboEnergieMacro->AddEntry("GeV",4);
  fComboEnergieMacro->AddEntry("TeV",5);


  fComboEnergieMacroLabel = new TGLabel(fComboem, "Choisissez l'unite de l'energie");
  fLComboEnergieMacroLabel = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsBottom | kLHintsTop, 2, 2, 2, 2);
  fComboem->AddFrame(fComboEnergieMacroLabel,fLComboEnergieMacroLabel);

  return fComboem;
}

TGCompositeFrame* G4EnergieMacro::BuildEnergieMacroInputEntry(const TGWindow* w)
{
  TGCompositeFrame *InputLineMacro = new TGCompositeFrame(w, 100, 100, kVerticalFrame);

  LEnergieMacroInputLine = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsBottom | kLHintsTop, 2, 2, 2, 2);

  fInputEnergieMacroEntry = new TGTextEntry(InputLineMacro, new TGTextBuffer(20));
  InputLineMacro->AddFrame(fInputEnergieMacroEntry, LEnergieMacroInputLine);

 fInputEnergieMacroLabel = new TGLabel(InputLineMacro, "Rentrez l'energie de la particule primaire");
  fLInputEnergieMacroLabel = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsBottom | kLHintsTop, 2, 2, 2, 2);
  InputLineMacro->AddFrame(fInputEnergieMacroLabel,fLInputEnergieMacroLabel);

  return InputLineMacro;
  }


ClassImpQ(G4EnergieMacro)
