#ifndef __G4EnergieMacro__
#define __G4EnergieMacro__

#include <TGFrame.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <TGLabel.h>

using std::string;


class TGTextEntry;
class TGButton;
class TGLabel;
class TGComboBox;
class TString;
class G4MacroMenu;

class G4EnergieMacro : public TGTransientFrame {

 public: 

  G4EnergieMacro(G4MacroMenu*, const TGWindow *p, const TGWindow *main, UInt_t w, UInt_t h, UInt_t options = kVerticalFrame);
  virtual ~G4EnergieMacro();

  virtual void CloseWindow();
  void OkEnergieMacro();
  void ClearEnergieMacro()           {fInputEnergieMacroEntry->Clear();}


  TGCompositeFrame* BuildEnergieMacroFrame(const TGWindow* q);
  TGCompositeFrame* BuildEnergieMacroButtonFrame(const TGWindow* p);
  TGCompositeFrame* BuildEnergieMacroDefFrame(const TGWindow* r);
  TGCompositeFrame* BuildEnergieMacroInputEntry(const TGWindow* w);
  TGCompositeFrame* BuildEnergieMacroComboFrame(const TGWindow* a);

 private:

  TGCompositeFrame*  fEnergieMacroFrame;
  TGCompositeFrame*  fEnergieMacroDefFrame;
  TGCompositeFrame*  fEnergieMacroInputFrame;
  TGCompositeFrame*  fEnergieMacroComboFrame;
  TGCompositeFrame*  fEnergieMacroButtonFrame;

  TGLayoutHints*     fLEnergieMacroInputEntry;
  TGLayoutHints*     fLEnergieMacroButtonFrame;
  TGLayoutHints*     fLEnergieMacroFrame;
  TGLayoutHints*     fLEnergieMacroDefFrame;
  TGLayoutHints*     fButtonem;
  TGLayoutHints*     LEnergieMacroInputLine;
  TGLayoutHints*     fLInputEnergieMacroLabel;
  TGLayoutHints*     fLEnergieMacroComboFrame;
  TGLayoutHints*     fLComboem;
  TGLayoutHints*     fLComboEnergieMacroLabel;
  TGLayoutHints*     LEnergieMacroFrame;
  TGLayoutHints*     LEnergieMacroDefFrame;
  TGLayoutHints*     fLEnergieMacroDefLabel;

  TGTextButton*      fOkEnergieMacroButton;
  TGTextButton*      fClearEnergieMacroButton;
  TGTextButton*      fExitEnergieMacroButton;

  TGLabel*           fInputEnergieMacroLabel;
  TGLabel*           fComboEnergieMacroLabel;
  TGLabel*           fDefEnergieMacroLabel;

  TGComboBox*        fComboEnergieMacro;

  TGTextEntry*       fInputEnergieMacroEntry;
  TGTextEntry*       fDefEnergieMacroEntry;

  G4MacroMenu*       emacroMenu;

  string             unitmacro;


  ClassDef(G4EnergieMacro,0)

    };

#endif
