#include "G4MacroMenu.hh"
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <TGLabel.h>
#include <TGButton.h>
#include <TGClient.h>
#include <TSystem.h>
#include "TGTextView.h"
#include <stdio.h>
#include "G4EnergieMacro.hh"
#include "G4TubeMat.hh"

using namespace std;

enum AliMenuMessageTypes {
  kM_NOM,
  kM_RUN,
  kM_GEOMETRIE,
  kM_DEFAUT,
  kM_SOURCE,
  kM_ANALYSE,
  kM_MINI,
  kM_EXECUTE,
  kM_EXIT
};

G4MacroMenu::G4MacroMenu(const TGWindow *p, UInt_t w, UInt_t h) : TGMainFrame(p, w, h) 
{
 
  fLRunFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY, 10, 10, 10, 10);
  fRunFrame = BuildRunFrame(this);
  AddFrame(fRunFrame, fLRunFrame);

  fLAnalyseFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY, 10, 10, 10, 10);
  fAnalyseFrame = BuildAnalyseFrame(this);
  AddFrame(fAnalyseFrame, fLAnalyseFrame);

  fLNomFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY, 10, 10, 10, 10);
  fNomFrame = BuildNomFrame(this);
  AddFrame(fNomFrame, fLNomFrame);

  fLGeometrieFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY, 10, 10, 10, 10);
  fGeometrieFrame = BuildGeometrieFrame(this);
  AddFrame(fGeometrieFrame, fLGeometrieFrame);

  fLSourceFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY, 10, 10, 10, 10);
  fSourceFrame = BuildSourceFrame(this);
  AddFrame(fSourceFrame, fLSourceFrame);

  fLMiniFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY, 10, 10, 10, 10);
  fMiniFrame = BuildMiniFrame(this);
  AddFrame(fMiniFrame, fLMiniFrame);

  fLButtonFrame = new TGLayoutHints(kLHintsCenterX, 10, 10, 1, 1);
  fButtonFrame = BuildButtonFrame(this);
  AddFrame(fButtonFrame, fLButtonFrame);

  fLExecuteButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 10, 10, 1, 1);
  fExecuteButtonFrame = BuildExecuteButtonFrame(fButtonFrame);
  fButtonFrame->AddFrame(fExecuteButtonFrame, fLExecuteButtonFrame);

  fLExecuteButton = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 10, 10, 1, 1);
  fExecuteButton = BuildExecuteButton(fExecuteButtonFrame);
  fExecuteButtonFrame->AddFrame(fExecuteButton, fLExecuteButton);

  fLExitButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 10, 10, 1, 1);
  fExitButtonFrame = BuildExitButtonFrame(fButtonFrame);
  fButtonFrame->AddFrame(fExitButtonFrame, fLExitButtonFrame);

  fLExitButton = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 10, 10, 1, 1);
  fExitButton = BuildExitButton(fExitButtonFrame);
  fExitButtonFrame->AddFrame(fExitButton, fLExitButton);

  MapSubwindows();

  SetWindowName("menu principal pour modeliser le detecteur");

  Layout();

  MapWindow();

}

G4MacroMenu::~G4MacroMenu()
{
  //boutons
  if (fTNomButton)
    delete fTNomButton;
  if (fTRunButton)
  delete fTRunButton;
  if (fTGeometrieButton)
    delete fTGeometrieButton;
  if (fTDefautButton)
    delete fTDefautButton;
  if (fTSourceButton)
    delete fTSourceButton;
  if (fTAnalyseButton)
    delete fTAnalyseButton;
  if (fTMiniButton)
    delete fTMiniButton;
  if (fTExecuteButton)
    delete fTExecuteButton;
  if (fTExitButton)
  delete fTExitButton;

  //LayoutHints
  if (fLButtonFrame)
    delete fLButtonFrame;
  if (fLExecuteButtonFrame)
    delete fLExecuteButtonFrame;
  if (fLExecuteButton)
    delete fLExecuteButton;
  if (fLExecute)
    delete fLExecute;
  if (fLExitButtonFrame)
    delete fLExitButtonFrame;
  if (fLExitButton)
    delete fLExitButton;
  if (fLExit)
    delete fLExit;
  if (fLNomFrame)
    delete fLNomFrame;
  if (fLNomButtonFrame)
    delete fLNomButtonFrame;
  if (fLNomViewFrame)
    delete fLNomViewFrame;
  if (fLRunFrame)
    delete fLRunFrame;
  if (fLRunButtonFrame)
    delete fLRunButtonFrame;
  if (fLRunViewFrame)
    delete fLRunViewFrame;
  if (fLGeometrieFrame)
    delete fLGeometrieFrame;
  if (fLGeometrieButtonFrame)
    delete fLGeometrieButtonFrame;
  if (fLGeometrieViewFrame)
    delete fLGeometrieViewFrame;
  if (fLSourceFrame)
    delete fLSourceFrame;
  if (fLSourceButtonFrame)
    delete fLSourceButtonFrame;
  if (fLSourceViewFrame)
    delete fLSourceViewFrame;
  if (fLAnalyseFrame)
    delete fLAnalyseFrame;
  if (fLAnalyseButtonFrame)
    delete fLAnalyseButtonFrame;
  if (fLAnalyseViewFrame)
    delete fLAnalyseViewFrame;
  if (fLMiniFrame)
    delete fLMiniFrame;
  if (fLMiniButtonFrame)
    delete fLMiniButtonFrame;
  if (fLMiniViewFrame)
    delete fLMiniViewFrame;

  //frames
  if (fButtonFrame)
    delete fButtonFrame;
  if (fExecuteButtonFrame)
    delete fExecuteButtonFrame;
  if (fExecuteButton)
    delete fExecuteButton;
  if (fExitButtonFrame)
    delete fExitButtonFrame;
  if (fExitButton)
    delete fExitButton;
  if (fNomFrame)
    delete fNomFrame;
  if (fRunFrame)
    delete fRunFrame;
  if (fGeometrieFrame)
    delete fGeometrieFrame;
  if (fSourceFrame)
    delete fSourceFrame;
  if (fAnalyseFrame)
    delete fAnalyseFrame;
  if (fMiniFrame)
    delete fMiniFrame;

  //lignes de texte
  if (fNomTextView)
    delete fNomTextView;
  if (fRunTextView)
    delete fRunTextView;
  if (fGeometrieTextView)
    delete fGeometrieTextView;
  if (fSourceTextView)
    delete fSourceTextView;
  if (fAnalyseTextView)
    delete fAnalyseTextView;
  if (fMiniTextView)
  delete fMiniTextView;
}

void G4MacroMenu::CloseWindow() 
{
  delete this;
}

TGCompositeFrame* G4MacroMenu::BuildButtonFrame(const TGWindow* a)
{
  TGCompositeFrame *button = new TGCompositeFrame(a, 100, 100, kHorizontalFrame);

  return button;
}

TGCompositeFrame* G4MacroMenu::BuildExecuteButtonFrame(const TGWindow* b)
{
  TGCompositeFrame *ExecuteFrame = new TGCompositeFrame(b, 100, 100, kHorizontalFrame);

  return ExecuteFrame;
}

TGCompositeFrame* G4MacroMenu::BuildExecuteButton(const TGWindow* i)
{
  TGCompositeFrame *ExecuteButton = new TGCompositeFrame(i, 100, 100, kVerticalFrame);
  fLExecute = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 1, 1, 1, 1);

  fTExecuteButton = new TGTextButton(ExecuteButton, "&Execute", kM_EXECUTE);
  fTExecuteButton->Associate(this);
  fTExecuteButton->SetToolTipText("Execution en mode batch");
  fTExecuteButton->Connect("Clicked()", "G4MacroMenu", this, "macro()");
  ExecuteButton->AddFrame(fTExecuteButton, fLExecuteButton);

  return ExecuteButton;
  }

TGCompositeFrame* G4MacroMenu::BuildExitButtonFrame(const TGWindow* c)
{
  TGCompositeFrame *ExitFrame = new TGCompositeFrame(c, 100, 100, kHorizontalFrame);

  return ExitFrame;
}

TGCompositeFrame* G4MacroMenu::BuildExitButton(const TGWindow* j)
{
  TGCompositeFrame *ExitButton = new TGCompositeFrame(j, 100, 100, kVerticalFrame);
  fLExit = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 1, 1, 1, 1);

  fTExitButton = new TGTextButton(ExitButton, "&Exit", kM_EXIT);
  fTExitButton->Associate(this);
  fTExitButton->SetToolTipText("Ferme la fenetre");
  fTExitButton->SetCommand(".q");
  ExitButton->AddFrame(fTExitButton, fLExit);

  return ExitButton;
  }

TGCompositeFrame* G4MacroMenu::BuildNomFrame(const TGWindow* d)
{
  TGCompositeFrame *Nom = new TGCompositeFrame(d, 100, 100, kHorizontalFrame);

  //bouton
  fLNomButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fTNomButton = new TGTextButton(Nom, "&Nom", kM_NOM);
  fTNomButton->Associate(this);
  fTNomButton->SetToolTipText("Choix du nom du fichier de sortie");
  fTNomButton->Connect("Clicked()", "G4MacroMenu", this, "OutputName()");
  Nom->AddFrame(fTNomButton, fLNomButtonFrame);

  //zone de texte
  fLNomViewFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fNomTextView = new TGTextView(Nom, 650, 35); 
  Nom->AddFrame(fNomTextView, fLNomViewFrame);

  return Nom;
}

TGCompositeFrame* G4MacroMenu::BuildRunFrame(const TGWindow* e)
{
  TGCompositeFrame *Run = new TGCompositeFrame(e, 100, 100, kHorizontalFrame);

  //bouton
  fLRunButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fTRunButton = new TGTextButton(Run, "&Run", kM_RUN);
  fTRunButton->Associate(this);
  fTRunButton->SetToolTipText("Choix du nombre d'evenements a simuler");
  fTRunButton->Connect("Clicked()", "G4MacroMenu", this, "RunMenu()");
  Run->AddFrame(fTRunButton, fLRunButtonFrame);

  //zone de texte
  fLRunViewFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fRunTextView = new TGTextView(Run, 650, 35); 
  Run->AddFrame(fRunTextView, fLRunViewFrame);

  return Run;
}

TGCompositeFrame* G4MacroMenu::BuildGeometrieFrame(const TGWindow* f)
{
  TGCompositeFrame *Geometrie = new TGCompositeFrame(f, 100, 100, kHorizontalFrame);

  //bouton
  fLGeometrieButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fTGeometrieButton = new TGTextButton(Geometrie, "&Geometrie", kM_DEFAUT);
  fTGeometrieButton->Associate(this);
  fTGeometrieButton->SetToolTipText("Pour definir la geometrie du detecteur");
  fTGeometrieButton->Connect("Clicked()", "G4MacroMenu", this, "Geometrie()");
  Geometrie->AddFrame(fTGeometrieButton, fLGeometrieButtonFrame);

  fTDefautButton = new TGTextButton(Geometrie, "&Defaut", kM_GEOMETRIE);
  fTDefautButton->Associate(this);
  fTDefautButton->SetToolTipText("Pour avoir acces aux valeurs par defaut de la geometrie");
  fTDefautButton->Connect("Clicked()", "G4MacroMenu", this, "GeometrieDefaut()");
  Geometrie->AddFrame(fTDefautButton, fLGeometrieButtonFrame);

  //zone de texte
  fLGeometrieViewFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fGeometrieTextView = new TGTextView(Geometrie, 650, 35); 
  Geometrie->AddFrame(fGeometrieTextView, fLGeometrieViewFrame);

  return Geometrie;
}

TGCompositeFrame* G4MacroMenu::BuildSourceFrame(const TGWindow* g)
{
  TGCompositeFrame *Source = new TGCompositeFrame(g, 100, 100, kHorizontalFrame);

  //bouton
  fLSourceButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fTSourceButton = new TGTextButton(Source, "&Source", kM_SOURCE);
  fTSourceButton->Associate(this);
  fTSourceButton->SetToolTipText("Pour definir les parametres lies a la source radioactive");
  fTSourceButton->Connect("Clicked()", "G4MacroMenu", this, "Source()");
  Source->AddFrame(fTSourceButton, fLSourceButtonFrame);

  //zone de texte
  fLSourceViewFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fSourceTextView = new TGTextView(Source, 650, 35); 
  Source->AddFrame(fSourceTextView, fLSourceViewFrame);


  return Source;
}

TGCompositeFrame* G4MacroMenu::BuildAnalyseFrame(const TGWindow* f)
{
  TGCompositeFrame *Analyse = new TGCompositeFrame(f, 100, 100, kHorizontalFrame);

  //bouton
  fLAnalyseButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fTAnalyseButton = new TGTextButton(Analyse, "&Analyse", kM_ANALYSE);
  fTAnalyseButton->Associate(this);
  fTAnalyseButton->SetToolTipText("Pour definir les sorties de donnes de l'analyse");
  fTAnalyseButton->Connect("Clicked()", "G4MacroMenu", this, "Analyse()");
  Analyse->AddFrame(fTAnalyseButton, fLAnalyseButtonFrame);

  //zone de texte
  fLAnalyseViewFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fAnalyseTextView = new TGTextView(Analyse, 650, 35); 
  Analyse->AddFrame(fAnalyseTextView, fLAnalyseViewFrame);

  return Analyse;
}

TGCompositeFrame* G4MacroMenu::BuildMiniFrame(const TGWindow* k)
{
  TGCompositeFrame *Mini = new TGCompositeFrame(k, 100, 100, kHorizontalFrame);

  //bouton
  fLMiniButtonFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fTMiniButton = new TGTextButton(Mini, "&Minimisation", kM_MINI);
  fTMiniButton->Associate(this);
  fTMiniButton->SetToolTipText("Pour minimiser les parametres du detecteur");
  fTMiniButton->Connect("Clicked()", "G4MacroMenu", this, "Minimisation()");
  Mini->AddFrame(fTMiniButton, fLMiniButtonFrame);

  //zone de texte
  fLMiniViewFrame = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY | kLHintsTop | kLHintsBottom, 20, 20, 20, 20);

  fMiniTextView = new TGTextView(Mini, 650, 35); 
  Mini->AddFrame(fMiniTextView, fLMiniViewFrame);

  return Mini;
}

void G4MacroMenu::OutputName() 
{
}

void G4MacroMenu::Geometrie()
{
}

void G4MacroMenu::GeometrieDefaut()
{
}

void G4MacroMenu::RunMenu()
{
  fEnergieMacro = new G4EnergieMacro(this, fClient->GetRoot(), this, 700, 200);
  gSystem->ProcessEvents();
}

void G4MacroMenu::Source()
{
  fTubeMat = new G4TubeMat(this, fClient->GetRoot(), this, 800, 800);
  gSystem->ProcessEvents();
}

void G4MacroMenu::Analyse()
{
}

void G4MacroMenu::Minimisation()
{
}


void G4MacroMenu::macro()
{
}

void G4MacroMenu::MacroMenuError()
{
}

ClassImpQ(G4MacroMenu)

