#ifndef __G4MacroMenu__
#define __G4MacroMenu__

#include <TGFrame.h>
#include <TGClient.h>
#include <TGButton.h>
#include <TApplication.h>
#include <TGTextEntry.h>
#include <iostream>
#include <fstream>
#include <vector>
#include "G4EnergieMacro.hh"
#include "G4TubeMat.hh"

class TGTextEntry;
class TGButton;
class TGLabel;
class TApplication;
class TGTextView;
class TGText;
class G4EnergieMacro;
class G4TubeMat;

class G4MacroMenu : public TGMainFrame {

 public:

  G4MacroMenu(const TGWindow *p, UInt_t w, UInt_t h);
  virtual ~G4MacroMenu();

  virtual void CloseWindow();

  void RunMenu();
  void macro();
  void OutputName();
  void Geometrie();
  void GeometrieDefaut();
  void Source();
  void Analyse();
  void Minimisation();
  void MacroMenuError();

  TGTextView* GetNomTextView()              const {return fNomTextView;}
  TGTextView* GetRunTextView()              const {return fRunTextView;}
  TGTextView* GetGeometrieTextView()        const {return fGeometrieTextView;}
  TGTextView* GetSourceTextView()           const {return fSourceTextView;}
  TGTextView* GetAnalyseTextView()          const {return fAnalyseTextView;}
  TGTextView* GetMiniTextView()             const {return fMiniTextView;}

  TGCompositeFrame* BuildButtonFrame(const TGWindow*);
  TGCompositeFrame* BuildExecuteButtonFrame(const TGWindow*);
  TGCompositeFrame* BuildExecuteButton(const TGWindow*);
  TGCompositeFrame* BuildExitButtonFrame(const TGWindow*);
  TGCompositeFrame* BuildExitButton(const TGWindow*);
  TGCompositeFrame* BuildNomFrame(const TGWindow*);
  TGCompositeFrame* BuildRunFrame(const TGWindow*);
  TGCompositeFrame* BuildGeometrieFrame(const TGWindow*);
  TGCompositeFrame* BuildSourceFrame(const TGWindow*);
  TGCompositeFrame* BuildAnalyseFrame(const TGWindow*);
  TGCompositeFrame* BuildMiniFrame(const TGWindow*);


 private:

  TGLayoutHints*       fLButtonFrame;
  TGLayoutHints*       fLExecuteButtonFrame;
  TGLayoutHints*       fLExecuteButton;
  TGLayoutHints*       fLExecute;
  TGLayoutHints*       fLExitButtonFrame;
  TGLayoutHints*       fLExitButton;
  TGLayoutHints*       fLExit;
  TGLayoutHints*       fLNomFrame;
  TGLayoutHints*       fLNomButtonFrame;
  TGLayoutHints*       fLNomViewFrame;
  TGLayoutHints*       fLRunFrame;
  TGLayoutHints*       fLRunButtonFrame;
  TGLayoutHints*       fLRunViewFrame;
  TGLayoutHints*       fLGeometrieFrame;
  TGLayoutHints*       fLGeometrieButtonFrame;
  TGLayoutHints*       fLGeometrieViewFrame;
  TGLayoutHints*       fLSourceFrame;
  TGLayoutHints*       fLSourceButtonFrame;
  TGLayoutHints*       fLSourceViewFrame;
  TGLayoutHints*       fLAnalyseFrame;
  TGLayoutHints*       fLAnalyseButtonFrame;
  TGLayoutHints*       fLAnalyseViewFrame;
  TGLayoutHints*       fLMiniFrame;
  TGLayoutHints*       fLMiniButtonFrame;
  TGLayoutHints*       fLMiniViewFrame;

  TGCompositeFrame*    fButtonFrame;
  TGCompositeFrame*    fExecuteButtonFrame;
  TGCompositeFrame*    fExecuteButton;
  TGCompositeFrame*    fExitButtonFrame;
  TGCompositeFrame*    fExitButton;
  TGCompositeFrame*    fNomFrame;
  TGCompositeFrame*    fRunFrame;
  TGCompositeFrame*    fGeometrieFrame;
  TGCompositeFrame*    fSourceFrame;
  TGCompositeFrame*    fAnalyseFrame;
  TGCompositeFrame*    fMiniFrame;

  TGTextView*          fNomTextView;
  TGTextView*          fRunTextView;
  TGTextView*          fGeometrieTextView;
  TGTextView*          fSourceTextView;
  TGTextView*          fAnalyseTextView;
  TGTextView*          fMiniTextView;

  TGTextButton*        fTNomButton;
  TGTextButton*        fTRunButton;
  TGTextButton*        fTGeometrieButton;
  TGTextButton*        fTDefautButton;
  TGTextButton*        fTSourceButton;
  TGTextButton*        fTAnalyseButton;
  TGTextButton*        fTMiniButton;
  TGTextButton*        fTExecuteButton;
  TGTextButton*        fTExitButton;

  G4EnergieMacro*      fEnergieMacro;
  G4TubeMat*           fTubeMat;

  ClassDef(G4MacroMenu,0)

};

#endif
