#ifndef __G4TubeMat__
#define __G4TubeMat__

#include <TGFrame.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <TGLabel.h>

using std::string;


class TGTextEntry;
class TGButton;
class TGLabel;
class TString;
class G4MacroMenu;

class G4TubeMat : public TGTransientFrame {

 public: 

  G4TubeMat(G4MacroMenu*, const TGWindow *p, const TGWindow *main, UInt_t w, UInt_t h, UInt_t options = kVerticalFrame);
  virtual ~G4TubeMat();

  virtual void CloseWindow();
  void OkTubeMat();
  void ClearAllTubeMat();

  Double_t OCalc(Double_t, Double_t, Double_t, Double_t, Double_t, Double_t, Double_t, Double_t, Double_t, Double_t, Double_t, Double_t);
  Double_t HCalc(Double_t);
  Double_t AlCalc(Double_t);
  Double_t SiCalc(Double_t);
  Double_t MgCalc(Double_t);
  Double_t PCalc(Double_t);
  Double_t TiCalc(Double_t);
  Double_t KCalc(Double_t);
  Double_t NaCalc(Double_t);
  Double_t CaCalc(Double_t);
  Double_t MnCalc(Double_t);
  Double_t FeCalc(Double_t, Double_t);


  TGCompositeFrame* BuildTubeMatFM1Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatFM2Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatFM3Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatFM4Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatFM5Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatFM6Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatFM7Frame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatButtonFrame(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputNameEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputNameDefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputDensityEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputDensityDefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputSiO2Entry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputSiO2DefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputAl2O3Entry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputAl2O3DefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputFe2O3Entry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputFe2O3DefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputFeOEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputFeODefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputMgOEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputMgODefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputCaOEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputCaODefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputNa2OEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputNa2ODefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputK2OEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputK2ODefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputTiO2Entry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputTiO2DefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputP2O5Entry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputP2O5DefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputMnOEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputMnODefEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputH2OEntry(const TGWindow*);
  TGCompositeFrame* BuildTubeMatInputH2ODefEntry(const TGWindow*);

 private:

  TGCompositeFrame*  fTubeMatFM1Frame;
  TGCompositeFrame*  fTubeMatFM2Frame;
  TGCompositeFrame*  fTubeMatFM3Frame;
  TGCompositeFrame*  fTubeMatFM4Frame;
  TGCompositeFrame*  fTubeMatFM5Frame;
  TGCompositeFrame*  fTubeMatFM6Frame;
  TGCompositeFrame*  fTubeMatFM7Frame;
  TGCompositeFrame*  fTubeMatInputNameFrame;
  TGCompositeFrame*  fTubeMatInputNameDefFrame;
  TGCompositeFrame*  fTubeMatInputDensityFrame;
  TGCompositeFrame*  fTubeMatInputDensityDefFrame;
  TGCompositeFrame*  fTubeMatInputSiO2Frame;
  TGCompositeFrame*  fTubeMatInputSiO2DefFrame;
  TGCompositeFrame*  fTubeMatInputAl2O3Frame;
  TGCompositeFrame*  fTubeMatInputAl2O3DefFrame;
  TGCompositeFrame*  fTubeMatInputFe2O3Frame;
  TGCompositeFrame*  fTubeMatInputFe2O3DefFrame;
  TGCompositeFrame*  fTubeMatInputFeOFrame;
  TGCompositeFrame*  fTubeMatInputFeODefFrame;
  TGCompositeFrame*  fTubeMatInputMgOFrame;
  TGCompositeFrame*  fTubeMatInputMgODefFrame;
  TGCompositeFrame*  fTubeMatInputCaOFrame;
  TGCompositeFrame*  fTubeMatInputCaODefFrame;
  TGCompositeFrame*  fTubeMatInputNa2OFrame;
  TGCompositeFrame*  fTubeMatInputNa2ODefFrame;
  TGCompositeFrame*  fTubeMatInputK2OFrame;
  TGCompositeFrame*  fTubeMatInputK2ODefFrame;
  TGCompositeFrame*  fTubeMatInputTiO2Frame;
  TGCompositeFrame*  fTubeMatInputTiO2DefFrame;
  TGCompositeFrame*  fTubeMatInputP2O5Frame;
  TGCompositeFrame*  fTubeMatInputP2O5DefFrame;
  TGCompositeFrame*  fTubeMatInputMnOFrame;
  TGCompositeFrame*  fTubeMatInputMnODefFrame;
  TGCompositeFrame*  fTubeMatInputH2OFrame;
  TGCompositeFrame*  fTubeMatInputH2ODefFrame;
  TGCompositeFrame*  fTubeMatButtonFrame;

  TGLayoutHints*     fLTubeMatFM1Frame;
  TGLayoutHints*     fLTubeMatFM2Frame;
  TGLayoutHints*     fLTubeMatFM3Frame;
  TGLayoutHints*     fLTubeMatFM4Frame;
  TGLayoutHints*     fLTubeMatFM5Frame;
  TGLayoutHints*     fLTubeMatFM6Frame;
  TGLayoutHints*     fLTubeMatFM7Frame;
  TGLayoutHints*     fLTubeMatButtonFrame;
  TGLayoutHints*     fLTubeMatInputName;
  TGLayoutHints*     fLTubeMatInputNameDef;
  TGLayoutHints*     fLTubeMatInputDensity;
  TGLayoutHints*     fLTubeMatInputDensityDef;
  TGLayoutHints*     fLTubeMatInputSiO2;
  TGLayoutHints*     fLTubeMatInputSiO2Def;
  TGLayoutHints*     fLTubeMatInputAl2O3;
  TGLayoutHints*     fLTubeMatInputAl2O3Def;
  TGLayoutHints*     fLTubeMatInputFe2O3;
  TGLayoutHints*     fLTubeMatInputFe2O3Def;
  TGLayoutHints*     fLTubeMatInputFeO;
  TGLayoutHints*     fLTubeMatInputFeODef;
  TGLayoutHints*     fLTubeMatInputMgO;
  TGLayoutHints*     fLTubeMatInputMgODef;
  TGLayoutHints*     fLTubeMatInputCaO;
  TGLayoutHints*     fLTubeMatInputCaODef;
  TGLayoutHints*     fLTubeMatInputNa2O;
  TGLayoutHints*     fLTubeMatInputNa2ODef;
  TGLayoutHints*     fLTubeMatInputK2O;
  TGLayoutHints*     fLTubeMatInputK2ODef;
  TGLayoutHints*     fLTubeMatInputTiO2;
  TGLayoutHints*     fLTubeMatInputTiO2Def;
  TGLayoutHints*     fLTubeMatInputP2O5;
  TGLayoutHints*     fLTubeMatInputP2O5Def;
  TGLayoutHints*     fLTubeMatInputMnO;
  TGLayoutHints*     fLTubeMatInputMnODef;
  TGLayoutHints*     fLTubeMatInputH2O;
  TGLayoutHints*     fLTubeMatInputH2ODef;
  TGLayoutHints*     LMatFM1;
  TGLayoutHints*     LMatFM2;
  TGLayoutHints*     LMatFM3;
  TGLayoutHints*     LMatFM4;
  TGLayoutHints*     LMatFM5;
  TGLayoutHints*     LMatFM6;
  TGLayoutHints*     LMatFM7;
  TGLayoutHints*     LMatMacroInputLineName;
  TGLayoutHints*     LMatMacroInputLineNameDef;
  TGLayoutHints*     LMatMacroInputLineDensity;
  TGLayoutHints*     LMatMacroInputLineDensityDef;
  TGLayoutHints*     LMatMacroInputLineSiO2;
  TGLayoutHints*     LMatMacroInputLineSiO2Def;
  TGLayoutHints*     LMatMacroInputLineAl2O3;
  TGLayoutHints*     LMatMacroInputLineAl2O3Def;
  TGLayoutHints*     LMatMacroInputLineFe2O3;
  TGLayoutHints*     LMatMacroInputLineFe2O3Def;
  TGLayoutHints*     LMatMacroInputLineFeO;
  TGLayoutHints*     LMatMacroInputLineFeODef;
  TGLayoutHints*     LMatMacroInputLineMgO;
  TGLayoutHints*     LMatMacroInputLineMgODef;
  TGLayoutHints*     LMatMacroInputLineCaO;
  TGLayoutHints*     LMatMacroInputLineCaODef;
  TGLayoutHints*     LMatMacroInputLineNa2O;
  TGLayoutHints*     LMatMacroInputLineNa2ODef;
  TGLayoutHints*     LMatMacroInputLineK2O;
  TGLayoutHints*     LMatMacroInputLineK2ODef;
  TGLayoutHints*     LMatMacroInputLineTiO2;
  TGLayoutHints*     LMatMacroInputLineTiO2Def;
  TGLayoutHints*     LMatMacroInputLineP2O5;
  TGLayoutHints*     LMatMacroInputLineP2O5Def;
  TGLayoutHints*     LMatMacroInputLineMnO;
  TGLayoutHints*     LMatMacroInputLineMnODef;
  TGLayoutHints*     LMatMacroInputLineH2O;
  TGLayoutHints*     LMatMacroInputLineH2ODef;
  TGLayoutHints*     fLInputMatNameLabel;
  TGLayoutHints*     fLInputMatNameDefLabel;
  TGLayoutHints*     fLInputMatDensityLabel;
  TGLayoutHints*     fLInputMatDensityDefLabel;
  TGLayoutHints*     fLInputMatSiO2Label;
  TGLayoutHints*     fLInputMatSiO2DefLabel;
  TGLayoutHints*     fLInputMatAl2O3Label;
  TGLayoutHints*     fLInputMatAl2O3DefLabel;
  TGLayoutHints*     fLInputMatFe2O3Label;
  TGLayoutHints*     fLInputMatFe2O3DefLabel;
  TGLayoutHints*     fLInputMatFeOLabel;
  TGLayoutHints*     fLInputMatFeODefLabel;
  TGLayoutHints*     fLInputMatMgOLabel;
  TGLayoutHints*     fLInputMatMgODefLabel;
  TGLayoutHints*     fLInputMatCaOLabel;
  TGLayoutHints*     fLInputMatCaODefLabel;
  TGLayoutHints*     fLInputMatNa2OLabel;
  TGLayoutHints*     fLInputMatNa2ODefLabel;
  TGLayoutHints*     fLInputMatK2OLabel;
  TGLayoutHints*     fLInputMatK2ODefLabel;
  TGLayoutHints*     fLInputMatTiO2Label;
  TGLayoutHints*     fLInputMatTiO2DefLabel;
  TGLayoutHints*     fLInputMatP2O5Label;
  TGLayoutHints*     fLInputMatP2O5DefLabel;
  TGLayoutHints*     fLInputMatMnOLabel;
  TGLayoutHints*     fLInputMatMnODefLabel;
  TGLayoutHints*     fLInputMatH2OLabel;
  TGLayoutHints*     fLInputMatH2ODefLabel;
  TGLayoutHints*     fButtonpm;

  TGTextButton*      fOkTubeMatButton;
  TGTextButton*      fClearAllTubeMatButton;
  TGTextButton*      fExitTubeMatButton;

  TGLabel*           fInputTubeMatNameLabel;
  TGLabel*           fInputTubeMatNameDefLabel;
  TGLabel*           fInputTubeMatDensityLabel;
  TGLabel*           fInputTubeMatDensityDefLabel;
  TGLabel*           fInputTubeMatSiO2Label;
  TGLabel*           fInputTubeMatSiO2DefLabel;
  TGLabel*           fInputTubeMatAl2O3Label;
  TGLabel*           fInputTubeMatAl2O3DefLabel;
  TGLabel*           fInputTubeMatFe2O3Label;
  TGLabel*           fInputTubeMatFe2O3DefLabel;
  TGLabel*           fInputTubeMatFeOLabel;
  TGLabel*           fInputTubeMatFeODefLabel;
  TGLabel*           fInputTubeMatMgOLabel;
  TGLabel*           fInputTubeMatMgODefLabel;
  TGLabel*           fInputTubeMatCaOLabel;
  TGLabel*           fInputTubeMatCaODefLabel;
  TGLabel*           fInputTubeMatNa2OLabel;
  TGLabel*           fInputTubeMatNa2ODefLabel;
  TGLabel*           fInputTubeMatK2OLabel;
  TGLabel*           fInputTubeMatK2ODefLabel;
  TGLabel*           fInputTubeMatTiO2Label;
  TGLabel*           fInputTubeMatTiO2DefLabel;
  TGLabel*           fInputTubeMatP2O5Label;
  TGLabel*           fInputTubeMatP2O5DefLabel;
  TGLabel*           fInputTubeMatMnOLabel;
  TGLabel*           fInputTubeMatMnODefLabel;
  TGLabel*           fInputTubeMatH2OLabel;
  TGLabel*           fInputTubeMatH2ODefLabel;


  TGTextEntry*       fInputTubeMatNameEntry;
  TGTextEntry*       fInputTubeMatNameDefEntry;
  TGTextEntry*       fInputTubeMatDensityEntry;
  TGTextEntry*       fInputTubeMatDensityDefEntry;
  TGTextEntry*       fInputTubeMatSiO2Entry;
  TGTextEntry*       fInputTubeMatSiO2DefEntry;
  TGTextEntry*       fInputTubeMatAl2O3Entry;
  TGTextEntry*       fInputTubeMatAl2O3DefEntry;
  TGTextEntry*       fInputTubeMatFe2O3Entry;
  TGTextEntry*       fInputTubeMatFe2O3DefEntry;
  TGTextEntry*       fInputTubeMatFeOEntry;
  TGTextEntry*       fInputTubeMatFeODefEntry;
  TGTextEntry*       fInputTubeMatMgOEntry;
  TGTextEntry*       fInputTubeMatMgODefEntry;
  TGTextEntry*       fInputTubeMatCaOEntry;
  TGTextEntry*       fInputTubeMatCaODefEntry;
  TGTextEntry*       fInputTubeMatNa2OEntry;
  TGTextEntry*       fInputTubeMatNa2ODefEntry;
  TGTextEntry*       fInputTubeMatK2OEntry;
  TGTextEntry*       fInputTubeMatK2ODefEntry;
  TGTextEntry*       fInputTubeMatTiO2Entry;
  TGTextEntry*       fInputTubeMatTiO2DefEntry;
  TGTextEntry*       fInputTubeMatP2O5Entry;
  TGTextEntry*       fInputTubeMatP2O5DefEntry;
  TGTextEntry*       fInputTubeMatMnOEntry;
  TGTextEntry*       fInputTubeMatMnODefEntry;
  TGTextEntry*       fInputTubeMatH2OEntry;
  TGTextEntry*       fInputTubeMatH2ODefEntry;

  G4MacroMenu*       tmmacroMenu;


  ClassDef(G4TubeMat,0)

    };

#endif
